<?php
// -------------------------------------------------------------
//
// $Id$
//
// FILENAME  : lang_main.php [ English ]
// STARTED   : Sat Dec 16, 2000
// COPYRIGHT :  2001, 2003 phpBB Group
// WWW       : http://www.phpbb.com/
// LICENCE   : GPL vs2.0 [ see /docs/COPYING ] 
// 
// -------------------------------------------------------------

// DEVELOPERS PLEASE NOTE 
//
// Placeholders can now contain order information, e.g. instead of
// 'Page %s of %s' you can (and should) write 'Page %1$s of %2$s', this allows
// translators to re-order the output of data while ensuring it remains correct
//
// You do not need this where single placeholders are used, e.g. 'Message %d' is fine
// equally where a string contains only two placeholders which are used to wrap text
// in a url you again do not need to specify an order e.g., 'Click %sHERE%s' is fine

$lang = array(
	'ENCODING'		=> 'iso-8859-15',
	'DIRECTION'		=> 'ltr',
	'LEFT'			=> 'left',
	'RIGHT'			=> 'right',
	'DATE_FORMAT'	=> 'd M Y',

	'FORUM'			=> 'Forum',
	'SUBFORUM'		=> 'Subforum',
	'SUBFORUMS'		=> 'Subforums',
	'TOPIC'			=> 'Topic',
	'TOPICS'		=> 'Topics',
	'REPLIES'		=> 'Replies',
	'VIEWS'			=> 'Views',
	'POST'			=> 'Post',
	'POSTS'			=> 'Posts',
	'ANNOUNCEMENTS'	=> 'Announcements', 
	'POSTED'		=> 'Posted',
	'RATING'		=> 'Rating',
	'USERNAME'		=> 'Username',
	'PASSWORD'		=> 'Password',
	'EMAIL'			=> 'Email',
	'POSTER'		=> 'Poster',
	'AUTHOR'		=> 'Author',
	'TIME'			=> 'Time',
	'HOURS'			=> 'Hours',
	'MESSAGE'		=> 'Message',
	'POST_TIME'		=> 'Post time',
	'TOPIC_TIME'	=> 'Topic time',

	'1_DAY'		=> '1 Day',
	'7_DAYS'	=> '7 Days',
	'2_WEEKS'	=> '2 Weeks',
	'1_MONTH'	=> '1 Month',
	'3_MONTHS'	=> '3 Months',
	'6_MONTHS'	=> '6 Months',
	'1_YEAR'	=> '1 Year',
	'ASCENDING' => 'Ascending',
	'DESCENDING'=> 'Descending',

	'GO'		=> 'Go',
	'JUMP_TO'	=> 'Jump to',
	'SEARCH_FOR' => 'Search for', 
	'SUBMIT'	=> 'Submit',
	'RESET'		=> 'Reset',
	'CANCEL'	=> 'Cancel',
	'PREVIEW'	=> 'Preview',
	'CONFIRM'	=> 'Confirm',
	'DELETE'	=> 'Delete',
	'SPELLCHECK' => 'Spellcheck',
	'YES'		=> 'Yes',
	'NO'		=> 'No',
	'ENABLED'	=> 'Enabled',
	'DISABLED'	=> 'Disabled',
	'SELECT'	=>	'Select',
	'ERROR'		=> 'Error',
	'NEXT'		=> 'Next',
	'PREVIOUS'	=> 'Previous',
	'GOTO_PAGE' => 'Goto page',
	'JUMP_PAGE'	=> 'Enter the page number you wish to goto', 
	'START_PAGE' => 'Make my start page',
	'JOINED'	=> 'Joined',
	'IP_ADDRESS' => 'IP Address',
	'SELECT_FORUM' => 'Select a forum',
	'VIEW_LATEST_POST' => 'View latest post',
	'VIEW_NEWEST_POST' => 'View newest post',
	'PAGE_OF' => 'Page <b>%1$d</b> of <b>%2$d</b>',

	'ICQ'		=> 'ICQ',
	'AIM'		=> 'AIM',
	'MSNM'		=> 'MSNM',
	'YIM'		=> 'YIM',
	'JABBER'	=> 'Jabber', 
	'RANK'		=> 'Rank',

	'FORUM_INDEX' => 'Board Index', 

	'ALL_TIMES' => 'All times are %s %s',
	'-13'	=> 'GMT - 13 Hours',
	'-12'	=> 'GMT - 12 Hours',
	'-11'	=> 'GMT - 11 Hours',
	'-10'	=> 'GMT - 10 Hours',
	'-9'	=> 'GMT - 9 Hours',
	'-8'	=> 'GMT - 8 Hours',
	'-7'	=> 'GMT - 7 Hours',
	'-6'	=> 'GMT - 6 Hours',
	'-5'	=> 'GMT - 5 Hours',
	'-4'	=> 'GMT - 4 Hours',
	'-3.5'	=> 'GMT - 3.5 Hours',
	'-3'	=> 'GMT - 3 Hours',
	'-2.5'	=> 'GMT - 2.5 Hours',
	'-2'	=> 'GMT - 2 Hours',
	'-1'	=> 'GMT - 1 Hours',
	'0'		=> 'GMT',
	'1'		=> 'GMT + 1 Hour',
	'2'		=> 'GMT + 2 Hours',
	'3'		=> 'GMT + 3 Hours',
	'3.5'	=> 'GMT + 3.5 Hours',
	'4'		=> 'GMT + 4 Hours',
	'4.5'	=> 'GMT + 4.5 Hours',
	'5'		=> 'GMT + 5 Hours',
	'5.5'	=> 'GMT + 5.5 Hours',
	'6'		=> 'GMT + 6 Hours',
	'6.5'	=> 'GMT + 6.5 Hours',
	'7'		=> 'GMT + 7 Hours',
	'8'		=> 'GMT + 8 Hours',
	'9'		=> 'GMT + 9 Hours',
	'9.5'	=> 'GMT + 9.5 Hours',
	'10'	=> 'GMT + 10 Hours',
	'10.5'	=> 'GMT + 10.5 Hours',
	'11'	=> 'GMT + 11 Hours',
	'12'	=> 'GMT + 12 Hours',
	'13'	=> 'GMT + 13 Hours',
	'tz'	=> array(
		'-13'	=> 'GMT - 13 Hours',
		'-12'	=> 'GMT - 12 Hours',
		'-11'	=> 'GMT - 11 Hours',
		'-10'	=> 'GMT - 10 Hours',
		'-9'	=> 'GMT - 9 Hours',
		'-8'	=> 'GMT - 8 Hours',
		'-7'	=> 'GMT - 7 Hours',
		'-6'	=> 'GMT - 6 Hours',
		'-5'	=> 'GMT - 5 Hours',
		'-4'	=> 'GMT - 4 Hours',
		'-3.5'	=> 'GMT - 3.5 Hours',
		'-3'	=> 'GMT - 3 Hours',
		'-2.5'	=> 'GMT - 2.5 Hours',
		'-2'	=> 'GMT - 2 Hours',
		'-1'	=> 'GMT - 1 Hours',
		'0'		=> 'GMT',
		'1'		=> 'GMT + 1 Hour',
		'2'		=> 'GMT + 2 Hours',
		'3'		=> 'GMT + 3 Hours',
		'3.5'	=> 'GMT + 3.5 Hours',
		'4'		=> 'GMT + 4 Hours',
		'4.5'	=> 'GMT + 4.5 Hours',
		'5'		=> 'GMT + 5 Hours',
		'5.5'	=> 'GMT + 5.5 Hours',
		'6'		=> 'GMT + 6 Hours',
		'6.5'	=> 'GMT + 6.5 Hours',
		'7'		=> 'GMT + 7 Hours',
		'8'		=> 'GMT + 8 Hours',
		'9'		=> 'GMT + 9 Hours',
		'9.5'	=> 'GMT + 9.5 Hours',
		'10'	=> 'GMT + 10 Hours',
		'10.5'	=> 'GMT + 10.5 Hours',
		'11'	=> 'GMT + 11 Hours',
		'12'	=> 'GMT + 12 Hours',
		'13'	=> 'GMT + 13 Hours',
		'dst'	=> '[ DST ]'
	),
	'AM' => 'AM',
	'PM' => 'PM', 
	'datetime' => array(
		'Sunday'	=> 'Sunday',
		'Monday'	=> 'Monday',
		'Tuesday'	=> 'Tuesday',
		'Wednesday' => 'Wednesday',
		'Thursday'	=> 'Thursday',
		'Friday'	=> 'Friday',
		'Saturday'	=> 'Saturday',
		'Sun' => 'Sun',
		'Mon' => 'Mon',
		'Tue' => 'Tue',
		'Wed' => 'Wed',
		'Thu' => 'Thu',
		'Fri' => 'Fri',
		'Sat' => 'Sat',
		'January'	=> 'January',
		'February'	=> 'February',
		'March'		=> 'March',
		'April'		=> 'April',
		'May'		=> 'May',
		'June'		=> 'June',
		'July'		=> 'July',
		'August'	=> 'August',
		'September' => 'September',
		'October'	=> 'October',
		'November'	=> 'November',
		'December'	=> 'December',
		'Jan' => 'Jan',
		'Feb' => 'Feb',
		'Mar' => 'Mar',
		'Apr' => 'Apr',
		'Jun' => 'Jun',
		'Jul' => 'Jul',
		'Aug' => 'Aug',
		'Sep' => 'Sep',
		'Oct' => 'Oct',
		'Nov' => 'Nov',
		'Dec' => 'Dec',
	),

	'POST_NEW_TOPIC'	=> 'Post new topic',
	'REPLY_TO_TOPIC'	=> 'Reply to topic',
	'REPLY_WITH_QUOTE'	=> 'Reply with quote',

	'RETURN_INDEX'	=> 'Click %sHere%s to return to the index',
	'RETURN_TOPIC'	=> 'Click %sHere%s to return to the topic',
	'RETURN_POST'	=> 'Click %sHere%s to return to the post',
	'RETURN_FORUM'	=> 'Click %sHere%s to return to the forum',
	'RETURN_LOGIN'	=> 'Click %sHere%s to try again',
	'RETURN_MCP'	=> 'Click %sHere%s to return to the Moderator Control Panel',
	'RETURN_GROUP'	=> 'Click %sHere%s to return to the Group Control Panel',
	'RETURN_UCP'	=> 'Click %sHere%s to return to the User Control Panel', 
	'VIEW_MESSAGE'	=> 'Click %sHere%s to view your message',
	'URL_REDIRECT'	=> 'If your browser does not support meta redirection please click %sHERE%s to be redirected.', 

	'INFORMATION'		=> 'Information',
	'BOARD_DISABLE'		=> 'Sorry but this board is currently unavailable',
	'BOARD_UNAVAILABLE' => 'Sorry but the board is temporarily unavailable, please try again in a few minutes',
	'BOARD_BAN_TIME'	=> 'You have been banned from this board until <b>%1$s</b>.<br /><br />Please contact the %2$sBoard Administrator%3$s for more information.',
	'BOARD_BAN_PERM'	=> 'You have been <b>permanently</b> banned from this board.<br /><br />Please contact the %2$sBoard Administrator%3$s for more information.', 
	'BOARD_BAN_REASON'	=> 'Reason given for ban: <b>%s</b>', 
	'EMAIL_DISABLED'	=> 'Sorry but all email related functions have been disabled.', 
	'REMOVE_INSTALL'	=> 'Please delete, move or rename the install directory.', 

	'G_ADMINISTRATORS' 	=> 'Administrators',
	'G_SUPER_MODERATORS'=> 'Super Moderators',
	'G_REGISTERED' 		=> 'Registered Users',
	'G_REGISTERED_COPPA'=> 'Registered COPPA Users',
	'G_INACTIVE' 		=> 'Unapproved Users',
	'G_INACTIVE_COPPA'	=> 'Unapproved COPPA Users',
	'G_GUESTS' 			=> 'Guests',
	'G_BANNED'			=> 'Banned Users', 

	'NO_NEW_POSTS'		=> 'No new posts',
	'NEW_POSTS'			=> 'New posts',
	'NEW_POST'			=> 'New post',
	'NO_NEW_POSTS_HOT'	=> 'No new posts [ Popular ]',
	'NEW_POSTS_HOT'		=> 'New posts [ Popular ]',
	'NO_NEW_POSTS_LOCKED' => 'No new posts [ Locked ]',
	'NEW_POSTS_LOCKED'	=> 'New posts [ Locked ]',
	'FORUM_LOCKED'		=> 'Forum Locked', 

	'YOU_LAST_VISIT'	=> 'You last visited on %s',
	'CURRENT_TIME'		=> 'The time now is %s',

	'LOGIN'			=> 'Login', 
	'LOGOUT_USER'	=> 'Logout [ %s ]', 
	'LOGOUT'		=> 'Logout', 
	'REGISTER'		=> 'Register',
	'PROFILE'		=> 'User Control Panel',
	'SEARCH'		=> 'Search',
	'MEMBERLIST'	=> 'Members',
	'FAQ'			=> 'FAQ',
	'USERS'			=> 'Users', 
	'USERGROUPS'	=> 'Groups',
	'LAST_POST'		=> 'Last Post',
	'MODERATOR'		=> 'Moderator',
	'MODERATORS'	=> 'Moderators',
	'New_pms'		=> '<b>%d</b> new messages',
	'New_pm'		=> '<b>%d</b> new message',
	'No_new_pm'		=> '<b>0</b> new messages',
	'Unread_pms'	=> '<b>%d</b> unread messages',
	'Unread_pm'		=> '<b>%d</b> unread message',
	'No_unread_pm'	=> '<b>0</b> unread messages',
	'You_new_pm'	=> 'A new private message is waiting for you in your Inbox',
	'You_new_pms'	=> 'New private messages are waiting for you in your Inbox',
	'You_no_new_pm' => 'No new private messages are waiting for you',

	'LEGEND'				=> 'Legend', 
	'REGISTERED_USERS'		=> 'Registered Users:',
	'BROWSING_FORUM_GUEST'	=> 'Users browsing this forum: %1$s and %2$d guest',
	'BROWSING_FORUM_GUESTS'	=> 'Users browsing this forum: %1$s and %2$d guests',

	'GUEST' => 'Guest',
	'ACP' => '[ %sAdministration Control Panel%s ]',
	'MCP' => '[ %sModerator Control Panel%s ]',

	'LOGIN_FORUM'	=> 'To view or post in this forum you must enter a password.', 
	'WRONG_PASSWORD'=> 'You entered an incorrect password.', 

	'KARMA' => array(
		'-5'	=> 'Extremely Bad',
		'-4'	=> 'Very Bad', 
		'-3'	=> 'Very Poor', 
		'-2'	=> 'Bad',
		'-1'	=> 'Poor', 
		'0'		=> 'Neutral', 
		'1'		=> 'Positive',
		'2'		=> 'Good',
		'3'		=> 'Very Good', 
		'4'		=> 'Extremely good', 
		'5'		=> 'Excellent'
	),


	'INDEX'			=> 'Index page', 
	'REDIRECTS'		=> 'Total redirects', 
	'WHO_IS_ONLINE'	=> 'Who is Online',
	'BIRTHDAYS'		=> 'Birthdays', 

	'SEARCH_NEW'		=> 'View posts since last visit',
	'SEARCH_SELF'		=> 'View your posts',
	'SEARCH_UNANSWERED' => 'View unanswered posts',
	
	'MARK_FORUMS_READ'	=> 'Mark Forums Read',
	'FORUMS_MARKED'		=> 'All forums have been marked read',

	'CONGRATULATIONS'	=> 'Congratulations to', 
	'NO_BIRTHDAYS'		=> 'No birthdays today', 

	'RECORD_ONLINE_USERS'		=> 'Most users ever online was <b>%1$s</b> on %2$s',
	'ONLINE_USERS_ZERO_TOTAL'	=> 'In total there are <b>0</b> users online :: ',
	'ONLINE_USERS_TOTAL'		=> 'In total there are <b>%d</b> users online :: ',
	'ONLINE_USER_TOTAL'			=> 'In total there is <b>%d</b> user online :: ',
	'REG_USERS_ZERO_TOTAL'		=> '0 Registered, ',
	'REG_USERS_TOTAL'			=> '%d Registered, ',
	'REG_USER_TOTAL'			=> '%d Registered, ',
	'HIDDEN_USERS_ZERO_TOTAL'	=> '0 Hidden and ',
	'HIDDEN_USER_TOTAL'			=> '%d Hidden and ',
	'HIDDEN_USERS_TOTAL'		=> '%d Hidden and ',
	'GUEST_USERS_ZERO_TOTAL'	=> '0 Guests',
	'GUEST_USERS_TOTAL'			=> '%d Guests',
	'GUEST_USER_TOTAL'			=> '%d Guest',

	'POSTED_ARTICLES_ZERO_TOTAL'=> 'Our users have posted a total of <b>0</b> article',
	'POSTED_ARTICLES_TOTAL'		=> 'Our users have posted a total of <b>%d</b> articles',
	'POSTED_ARTICLE_TOTAL'		=> 'Our users have posted a total of <b>%d</b> article',
	'POSTED_TOPICS_ZERO_TOTAL'	=> 'Our users have posted a total of <b>0</b> topic',
	'POSTED_TOPICS_TOTAL'		=> 'Our users have posted a total of <b>%d</b> topics',
	'POSTED_TOPIC_TOTAL'		=> 'Our users have posted a total of <b>%d</b> topic',
	'NEWEST_USER'				=> 'The newest registered user is <b>%s%s%s</b>',
	'REGISTERED_USERS_ZERO_TOTAL'	=> 'We have <b>0</b> registered users',
	'REGISTERED_USERS_TOTAL'		=> 'We have <b>%d</b> registered users',
	'REGISTERED_USER_TOTAL'			=> 'We have <b>%d</b> registered user',


	'POST_STICKY' 		=> 'Sticky',
	'POST_ANNOUNCEMENT' => 'Announce',
	'POST_GLOBAL'		=> 'Global',
	'POST_FORUM_LOCKED' => 'Forum is locked',
	'POST_TOPIC_LOCKED' => 'Topic is locked', 


	'LIST_USER'	=> '1 User',
	'LIST_USERS'=> '%d Users',


	'LOGIN'			=> 'Login',
	'TERMS_USE'		=> 'Terms of Use', 
	'PRIVACY'		=> 'Privacy Policy', 
	'FORGOT_PASS'	=> 'I forgot my password',
	'LOG_ME_IN'		=> 'Log me on automatically each visit',
	'HIDE_ME'		=> 'Hide my online status this session', 
	'LOGIN_ERROR'	=> 'You have specified an incorrect username or password. Please check them both and try again. If you continue to have problems please contact a board administrator.',
	'ACTIVE_ERROR'	=> 'You have specified an inactive username. Please activate your account and try again. If you continue to have problems please contact a board administrator.',


	'Private_Message' => 'Private Message',
	'Private_Messages' => 'Private Messages',
	'View_forum' => 'View Forum',


	'DISPLAY_TOPICS'	=> 'Display topics from previous',
	'ALL_TOPICS'		=> 'All Topics',


	'VIEW_TOPIC_ANNOUNCEMENT'=> 'Announcement: ',
	'VIEW_TOPIC_STICKY'		=> 'Sticky: ',
	'VIEW_TOPIC_MOVED'		=> 'Moved: ',
	'VIEW_TOPIC_POLL'		=> 'Poll: ',
	'VIEW_TOPIC_LOCKED'		=> 'Locked: ',

	'MARK_TOPICS_READ'	=> 'Mark Topics Read',
	'TOPICS_MARKED'		=> 'The topics for this forum have now been marked read',
	'TOPIC_REPORTED'	=> 'This topic has been reported',
	'TOPIC_NOT_APPROVED'=> 'This topic has not been approved',


	'RULES_POST_CAN'		=> 'You <b>can</b> post new topics in this forum',
	'RULES_POST_CANNOT'		=> 'You <b>cannot</b> post new topics in this forum',
	'RULES_REPLY_CAN'		=> 'You <b>can</b> reply to topics in this forum',
	'RULES_REPLY_CANNOT'	=> 'You <b>cannot</b> reply to topics in this forum',
	'RULES_ATTACH_CAN'		=> 'You <b>can</b> post attachments in this forum',
	'RULES_ATTACH_CANNOT'	=> 'You <b>cannot</b> post attachments in this forum',
	'RULES_DOWNLOAD_CAN'	=> 'You <b>can</b> download attachments in this forum',
	'RULES_DOWNLOAD_CANNOT' => 'You <b>cannot</b> download attachments in this forum',
	'RULES_EDIT_CAN'		=> 'You <b>can</b> edit your posts in this forum',
	'RULES_EDIT_CANNOT'		=> 'You <b>cannot</b> edit your posts in this forum',
	'RULES_DELETE_CAN'		=> 'You <b>can</b> delete your posts in this forum',
	'RULES_DELETE_CANNOT'	=> 'You <b>cannot</b> delete your posts in this forum',
	'RULES_VOTE_CAN'		=> 'You <b>can</b> vote in polls in this forum',
	'RULES_VOTE_CANNOT'		=> 'You <b>cannot</b> vote in polls in this forum',


	'NO_MODE'	=> 'No mode specified.', 
	'NO_FORUMS' => 'This board has no forums',
	'NO_FORUM'	=> 'The forum you selected does not exist',
	'NO_TOPICS'	=> 'There are no topics or posts in this forum.', 
	'NO_TOPIC'	=> 'The requested topic does not exist.', 
	'NO_POSTS'	=> 'No Posts',
	'NO_POST'	=> 'The requested post does not exist.', 
	'NO_USER'	=> 'The requested user does not exist.', 
	'NO_GROUP'	=> 'The requested usergroup does not exist.', 
	'NO_UNREAD_POSTS'	=> 'There are no new unread posts for this topic.', 

	'LOGIN_VIEWFORUM'	=> 'The board administrator requires you to be registered and logged in to view this forum.', 
	'STOP_WATCHING_FORUM'	=> 'Unsubscribe Forum',
	'START_WATCHING_FORUM'	=> 'Subscribe Forum',
	'NOT_WATCHING_FORUM'	=> 'You no subscribe to updates on this forum',
	'ARE_WATCHING_FORUM'	=> 'You have subscribed to receive updates on this forum',

	'VIEW_FORUM_TOPIC'	=> '1 Topic',
	'VIEW_FORUM_TOPICS'	=> '%d Topics',
);

// viewtopic
$lang += array(
	'VIEW_TOPIC'			=> 'View topic',
	'LOGIN_VIEWTOPIC'		=> 'The board administrator requires you to be registered and logged in to view this topic.', 
	'PRINT_TOPIC'			=> 'Print View', 
	'EMAIL_TOPIC'			=> 'Email Friend', 
	'VIEW_NEXT_TOPIC'		=> 'Next topic',
	'VIEW_PREVIOUS_TOPIC'	=> 'Previous topic',
	'VIEW_UNREAD_POST'		=> 'First unread post', 

	'NO_NEWER_TOPICS'	=> 'There are no newer topics in this forum',
	'NO_OLDER_TOPICS'	=> 'There are no older topics in this forum', 
	'POST_IGNORE'		=> 'This post was made by <b>%1$s</b> who is on your ignore list. To display this post click %sHERE%s.', 
	'POST_BELOW_KARMA'	=> 'This post was made by <b>%1$s</b> whose karma rating of <b>%2$d</b> is below your desired minimum. To display this post click %3$sHERE%4$s.', 
	'POST_ENCODING'		=> 'This post by <b>%1$s</b> was made in a character set different to yours. To view this post in its proper encoding click %2$sHERE%3$s.', 
	'DISPLAY_POSTS'		=> 'Display posts from previous',
	'ALL_POSTS'			=> 'All Posts',

	'BACK_TO_TOP'		=> 'Top',
	'POST_SUBJECT'		=> 'Post subject',
	'KARMA_LEVEL'		=> 'Karma Level', 
	'READ_PROFILE'		=> 'Profile',
	'SEND_EMAIL'		=> 'Email',
	'VISIT_WEBSITE'		=> 'WWW',
	'ICQ_STATUS'		=> 'ICQ Status', 
	'RATE'				=> 'Rate', 
	'RATE_GOOD'			=> 'Good', 
	'RATE_BAD'			=> 'Bad', 
	'EDIT_POST'			=> 'Edit',
	'VIEW_IP'			=> 'IP',
	'DELETE_POST'		=> 'Delete',
	'DELETE_POST_WARN'	=> 'Once deleted the post cannot be recovered',
	'REPORT_POST'		=> 'Report this post',
	'EDITED_TIME_TOTAL'		=> 'Last edited by %1$s on %2$s, edited %3$d time in total',
	'EDITED_TIMES_TOTAL'	=> 'Last edited by %1$s on %2$s, edited %3$d times in total',

	'POST_REPORTED'		=> 'Click to view reports',
	'POST_NOT_APPROVED'	=> 'Click to approve post',

	'WROTE'	=> 'wrote',
	'QUOTE'	=> 'Quote',
	'CODE'	=> 'Code',

	'QUICK_MOD'			=>	'Quick-mod tools',
	'LOCK_TOPIC'		=>	'Lock Topic',
	'UNLOCK_TOPIC'		=>	'Unlock Topic',
	'MOVE_TOPIC'		=>	'Move Topic',
	'DELETE_TOPIC'		=>	'Delete Topic',
	'SPLIT_TOPIC'		=>	'Split Topic',
	'MERGE_TOPIC'		=>	'Merge Topic',
	'FORK_TOPIC'		=>	'Copy Topic',
	'MAKE_NORMAL'		=>	'Make Normal',
	'MAKE_STICKY'		=>	'Make Sticky',
	'MAKE_ANNOUNCE'		=>	'Make Announce',
	'MAKE_GLOBAL'		=>	'Make Global',
	'VIEW_TOPIC_LOGS'	=>	'View Logs',

	'STOP_WATCHING_TOPIC'	=> 'Unsubscribe Topic',
	'START_WATCHING_TOPIC'	=> 'Subscribe Topic',
	'NOT_WATCHING_TOPIC'	=> 'You are no longer subscribed to this topic.',
	'ARE_WATCHING_TOPIC'	=> 'You have subscribed to receive updates on this topic.',

	'ALREADY_VOTED'			=> 'You have already voted in this poll and may not change your selection.',
	'NO_VOTE_OPTION'		=> 'You must specify an option when voting.', 
	'TOO_MANY_VOTE_OPTIONS'	=> 'You have tried to vote for too many options.', 
	'SUBMIT_VOTE'			=> 'Submit Vote', 
	'MAX_OPTION_SELECT'		=> 'You may select <b>1</b> option', 
	'MAX_OPTIONS_SELECT'	=> 'You may select up to <b>%d</b> options', 
	'TOTAL_VOTES'			=> 'Total Votes',
	'VIEW_RESULTS'			=> 'View Results',
	'POLL_VOTED_OPTION'		=> 'You voted for this option', 
	'POLL_RUN_TILL'			=> 'Poll runs till %s', // %s = date/time
	'VOTE_SUBMITTED' 		=> 'Your vote has been cast',

	'RATING_UPDATED'		=> 'Your existing rating for this poster has been updated', 
	'RATING_ADDED'			=> 'Your rating for this poster has been saved.', 

	'VIEW_TOPIC_POST'	=> '1 Post',
	'VIEW_TOPIC_POSTS'	=> '%d Posts',
);

// posting
$lang += array(
	'BBCODE_B_HELP'		=> 'Bold text: [b]text[/b]  (alt+b)',
	'BBCODE_I_HELP'		=> 'Italic text: [i]text[/i]  (alt+i)',
	'BBCODE_U_HELP'		=> 'Underline text: [u]text[/u]  (alt+u)',
	'BBCODE_Q_HELP'		=> 'Quote text: [quote]text[/quote]  (alt+q)',
	'BBCODE_C_HELP'		=> 'Code display: [code]code[/code]  (alt+c)',
	'BBCODE_L_HELP'		=> 'List: [list]text[/list]  (alt+l)',
	'BBCODE_E_HELP'		=> 'List: Add list element',
	'BBCODE_O_HELP'		=> 'Ordered list: [list=]text[/list]  (alt+o)',
	'BBCODE_P_HELP'		=> 'Insert image: [img]http://image_url[/img]  (alt+p)',
	'BBCODE_W_HELP'		=> 'Insert URL: [url]http://url[/url] or [url=http://url]URL text[/url]  (alt+w)',
	'BBCODE_A_HELP'		=> 'Close all open bbCode tags',
	'BBCODE_S_HELP'		=> 'Font color: [color=red]text[/color]  Tip: you can also use color=#FF0000',
	'BBCODE_F_HELP'		=> 'Font size: [size=x-small]small text[/size]',
	'EMOTICONS' 		=> 'Emoticons',
	'MORE_EMOTICONS'	=> 'View more Emoticons',
	'FONT_COLOR' 		=> 'Font color',
	'FONT_SIZE' 		=> 'Font size',
	'FONT_TINY' 		=> 'Tiny',
	'FONT_SMALL' 		=> 'Small',
	'FONT_NORMAL' 		=> 'Normal',
	'FONT_LARGE' 		=> 'Large',
	'FONT_HUGE' 		=> 'Huge',
	'CLOSE_TAGS' 		=> 'Close Tags',
	'STYLES_TIP' 		=> 'Tip: Styles can be applied quickly to selected text',
	'CLOSE_WINDOW' 		=> 'Close Window',

	'MESSAGE_BODY' 			=> 'Message body',
	'MESSAGE_BODY_EXPLAIN'	=> 'Enter your message here, it may contain no more than <b>%d</b> characters.',
	'TOPIC_REVIEW' 			=> 'Topic review',
	'TOPIC_ICON' 			=> 'Topic icon',
	'POST_ICON' 			=> 'Post icon',
	'No_post_mode' 			=> 'No post mode specified',
	'POST_TOPIC' 			=> 'Post a new topic',
	'POST_REPLY' 			=> 'Post a reply',
	'POST_TOPIC_AS'			=> 'Post topic as',
	'CHANGE_TOPIC_TO'		=> 'Change topic type to',
	'EDIT_POST' 			=> 'Edit post',
	'OPTIONS' 				=> 'Options',
	'MOD_OPTIONS'			=> 'Moderator Options',
	'POST_NORMAL' 			=> 'Normal',
	'POST_REVIEW'			=> 'Post Review',
	'POST_REVIEW_EXPLAIN'	=> 'At least one new post has been made to this topic. You may wish to review your post inlight of this.',

	'LOCK_POST'			=> 'Lock Post',
	'LOCK_POST_EXPLAIN' => 'Prevent editing',

	'CONFIRM_DELETE'			=> 'Are you sure you want to delete this post?',
	'Confirm_delete_poll'		=> 'Are you sure you want to delete this poll?',
	'CANNOT_EDIT_TIME'			=> 'You can no longer edit or delete that post',
	'CANNOT_EDIT_POST_LOCKED'	=> 'This post has been locked. You can no longer edit that post.',
	'FLOOD_ERROR'				=> 'You cannot make another post so soon after your last.',
	'EMPTY_SUBJECT'				=> 'You must specify a subject when posting a new topic.',
	'To_long_subject'			=> 'The subject is too long it must be 60 characters or less.',
	'EMPTY_MESSAGE'				=> 'You must enter a message when posting.',
	'TOO_FEW_CHARS'				=> 'Your message contains too few characters.',
	'TOO_MANY_CHARS'			=> 'Your message contains too many characters.',
	'TOO_MANY_SMILIES'			=> 'Your message contains too many emoticons.',
	'UNAUTHORISED_BBCODE'		=> 'You cannot use certain bbcodes: ',
	'QUOTE_DEPTH_EXCEEDED'		=> 'You may embed only %1$d quotes within each other.',
	'Forum_locked'				=> 'This forum is locked you cannot post, reply to or edit topics',
	'Topic_locked'				=> 'This topic is locked you cannot edit posts or make replies',

	'USER_CANNOT_POST'		=> 'You cannot post in this forum',
	'USER_CANNOT_REPLY'		=> 'You cannot reply in this forum',
	'USER_CANNOT_QUOTE'		=> 'You cannot quote posts in this forum',
	'USER_CANNOT_EDIT'		=> 'You cannot edit posts in this forum',
	'USER_CANNOT_DELETE'	=> 'You cannot delete posts in this forum',
	'USER_CANNOT_POST'		=> 'You cannot report posts in this forum',
	'CANNOT_POST_STICKY'	=> 'Sorry but you cannot post sticky topics.', 
	'CANNOT_POST_ANNOUNCE'	=> 'Sorry but you cannot post announcements.', 
	'CANNOT_POST_NEWS'		=> 'Sorry but you cannot post news topics.', 
	'CANNOT_DELETE_REPLIED' => 'Sorry but you may only delete posts which have not been replied to.',
	'CANNOT_DELETE_POLL'	=> 'Sorry but you cannot delete an active poll.',
	'EDIT_OWN_POSTS'		=> 'Sorry but you can only edit your own posts.',
	'DELETE_OWN_POSTS'		=> 'Sorry but you can only delete your own posts.',
	'ALREADY_DELETED'		=> 'Sorry but this message is already deleted.',

	'No_such_post'		=> 'There is no such post, please return and try again',

	'ADD_POLL'				=> 'Add a Poll',
	'ADD_POLL_EXPLAIN'		=> 'If you do not want to add a poll to your topic leave the fields blank',
	'POLL_QUESTION'			=> 'Poll question',
	'POLL_OPTIONS'			=> 'Poll options',
	'POLL_OPTIONS_EXPLAIN'	=> 'Place each option on a new line. You may enter up to <b>%d</b> options',
	'POLL_FOR_EXPLAIN'		=> 'Enter 0 or leave blank for a never ending poll', 
	'POLL_MAX_OPTIONS'		=> 'Options per user', 
	'POLL_MAX_OPTIONS_EXPLAIN'	=> 'This is the number of options each user may select when voting.', 
	'POLL_FOR'				=> 'Run poll for',
	'DAYS'					=> 'Days',
	'POLL_DELETE'			=> 'Delete Poll',

	'ADD_ATTACHMENT'		=> 'Add an Attachment',
	'ADD_ATTACHMENT_EXPLAIN'=> 'If you wish to attach one or more files enter the details below',
	'ADD_FILE'			=> 'Add File',
	'FILENAME'			=> 'Filename',
	'FILE_COMMENT'		=> 'File comment',
	'POSTED_ATTACHMENTS'=> 'Posted attachments',
	'UPDATE_COMMENT'	=> 'Update comment',
	'DELETE_FILE'		=> 'Delete File',

	'DISABLE_HTML'		=> 'Disable HTML',
	'DISABLE_BBCODE'	=> 'Disable BBCode',
	'DISABLE_SMILIES'	=> 'Disable Smilies',
	'DISABLE_MAGIC_URL' => 'Do not automatically parse URLs',
	'HTML_IS_ON' 		=> 'HTML is <u>ON</u>',
	'HTML_IS_OFF' 		=> 'HTML is <u>OFF</u>',
	'BBCODE_IS_ON' 		=> '%sBBCode%s is <u>ON</u>',
	'BBCODE_IS_OFF'		=> '%sBBCode%s is <u>OFF</u>',
	'SMILIES_ARE_ON'	=> 'Smilies are <u>ON</u>',
	'SMILIES_ARE_OFF'	=> 'Smilies are <u>OFF</u>',
	'IMAGES_ARE_ON'		=> '[img] is <u>ON</u>',
	'IMAGES_ARE_OFF'	=> '[img] is <u>OFF</u>',
	'FLASH_IS_ON' 		=> '[flash] is <u>ON</u>',
	'FLASH_IS_OFF' 		=> '[flash] is <u>ON</u>',
	'ATTACH_SIG' 		=> 'Attach a signature (signatures can be altered via the UCP)',
	'NOTIFY_REPLY' 		=> 'Send me an email when a reply is posted',

	'SAVE' 				=> 'Save',
	'LOAD'				=> 'Load',
	'DRAFT_SAVED'		=> 'Post contents successfully saved as draft.<br />You are able to load this draft to posts you make, or view and edit them within your User Control Panel.',
	'ENTER_DRAFT_TITLE'	=> 'Enter draft title',
	'DRAFT_TITLE_EXPLAIN' => 'Now you are able to change the draft title directly. At the moment the draft title is similar to the post subject.',

	'UPDATE'			=> 'Update',

	'POST_STORED' 		=> 'Your message has been posted successfully',
	'POST_STORED_MOD'	=> 'Your message has been saved but requires approval',
	'DELETED'			=> 'Your message has been deleted successfully',
	'Poll_delete' 		=> 'Your poll has been deleted successfully',
	'Topic_reply_notification' => 'Topic Reply Notification',

	'TOO_FEW_POLL_OPTIONS'	=> 'You must enter at least two poll options',
	'TOO_MANY_POLL_OPTIONS' => 'You have tried to enter too many poll options',
	'NO_POLL_TITLE'			=> 'You have to enter a poll title',
	'NO_DELETE_POLL_OPTIONS'=> 'You cannot delete existing poll options',
	'TOO_MANY_USER_OPTIONS' => 'You cannot specify more Options per User than existing poll options',

	'GENERAL_UPLOAD_ERROR'		=> 'Could not upload Attachment to %s',
	'TOO_MANY_ATTACHMENTS'		=> 'Cannot add another attacment, %d is the maxmimum.',
	'INVALID_FILENAME'			=> '%s is an invalid filename',
	'DISALLOWED_EXTENSION'		=> 'The Extension %s is not allowed',
	'ALLOWED'					=> 'Allowed',
	'ATTACHMENT_PHP_SIZE_NA'	=> 'The attachment is too big.<br />Could not get determine the maximum size defined by PHP in php.ini.',
	'ATTACHMENT_PHP_SIZE_OVERRUN'=> 'The attachment is too big, maximum upload size is %d MB.<br />Please note this is set in php.ini and cannot be overriden.',
	'ATTACHMENT_TOO_BIG'		=> 'The attachment is too big, maximum size is %1d %2s',
	'ATTACH_QUOTA_REACHED'		=> 'Sorry, the board attachment quota has been reached.',
	'BYTES'						=> 'Bytes',
	'KB'						=> 'KB',
	'MB'						=> 'MB',
	'DOWNLOAD_NOTICE'			=> 'You do not have the required permissions to view the files attached to this post.', // Differate the case more?
	
	'EXTENSION_DISABLED_AFTER_POSTING' => 'The extension <b>%s</b> has been deactivated and can no longer be displayed.', // used in Posts and PM's, replace %s with extension
	'DESCRIPTION'			=> 'Description',
	'DOWNLOAD'				=> 'Download',
	'FILESIZE'				=> 'Filesize',
	'FILE_NOT_FOUND_404'	=> 'The file <b>%s</b> does not exist.',
	'DOWNLOADED'			=> 'Downloaded',
	'VIEWED'				=> 'Viewed',
	'DOWNLOAD_NUMBER'		=> '%d Time(s)', // replace %d with count <-- NEEDS CHANGING TO FOLLOWING
	'DOWNLOAD_NONE'			=> '0 Times',	// replace %d with count
	'DOWNLOAD_COUNT'		=> '%d Time',	// replace %d with count
	'DOWNLOAD_COUNTS'		=> '%d Times',	// replace %d with count
);

// ucp
$lang += array(
	'UCP'			=> 'User Control Panel',
	'UCP_OPTIONS'	=> 'Options', 

	'UCP_MAIN'		=> 'Overview',

	'UCP_FRONT'		=> 'Front page', 
	'UCP_WELCOME'	=> 'Welcome to the User Control Panel. From here you can monitor, view and update your profile, preferences, subscribed forums and topics. You can also send messages to other users (if permitted). Please ensure you read any announcements before continuing.', 
	'IMPORTANT_NEWS'=> 'Important announcements', 
	'YOUR_DETAILS'	=> 'Your activity', 
	'ONLINE_BUDDIES'=> 'Online Buddies',
	'UNREAD_NO_PM'	=> 'You have no unread private messages',
	'UNREAD_PM'		=> 'You have 1 unread private messages',
	'UNREAD_PMS'	=> 'You have $d unread private messages',
	'TOTAL_NO_PM'	=> '0 private messages in total',
	'TOTAL_PM'		=> '1 private messages in total',
	'TOTAL_PMS'		=> '$d private messages in total',

	'UCP_WATCHED'		=> 'Watched items', 
	'WATCHED_FORUMS'	=> 'Watched Forums',
	'WATCHED_TOPICS'	=> 'Watched Topics',
	'NO_WATCHED_FORUMS' => 'You are not watching any forums.',
	'NO_WATCHED_TOPICS' => 'You are not watching any topics.',
	'UNWATCH_MARKED'	=> 'Unwatch marked', 
	'UNWATCHED_FORUMS'	=> 'You are no longer watching the selected forums.',
	'UNWATCHED_TOPICS'	=> 'You are no longer watching the selected topics.',
	'UNWATCHED_FORUMS_TOPICS'=> 'You are no longer watching the selected forums or topics.',

	'UCP_DRAFTS'		=> 'Saved drafts',
	'DRAFTS_EXPLAIN'	=> 'Here you can view, edit and delete your saved drafts.',
	'VIEW_EDIT'			=> 'View/Edit',
	'DRAFT_TITLE'		=> 'Draft Title',
	'SAVE_DATE'			=> 'Saved at',
	'NEW_OR_DELETED_TOPIC' => 'New topic or deleted',
	'EDIT_DRAFT_EXPLAIN' => 'Here you are able to edit your draft.',
	'DRAFTS_DELETED'	=> 'All selected drafts were successfully deleted.',
	'DRAFT_UPDATED'		=> 'Draft successfully updated.',
	'EMPTY_DRAFT_TITLE' => 'You must enter a draft title',
	'EMPTY_DRAFT'		=> 'You must enter a message to submit your changes',
	'BACK_TO_DRAFTS'	=> 'Back to saved drafts',


	'UCP_PROFILE'		=> 'Profile', 

	'UCP_REG_DETAILS'				=> 'Registration details', 
	'USERNAME_CHARS_ANY_EXPLAIN'	=> 'Length must be between %1$d and %2$d characters.', 
	'USERNAME_ALPHA_ONLY_EXPLAIN'	=> 'Username must be between %1$d and %2$d chars long and use only alphanumeric characters', 
	'USERNAME_ALPHA_SPACERS_EXPLAIN'=> 'Username must be between %1$d and %2$d chars long and use alphanumeric, space or -+_[] characters.', 
	'CHANGE_PASSWORD'				=> 'Change password', 
	'CHANGE_PASSWORD_EXPLAIN'		=> 'Must be between %1$d and %2$d characters.',
	'CURRENT_PASSWORD'				=> 'Current password', 
	'CURRENT_PASSWORD_EXPLAIN'		=> 'You must confirm your current password if you wish to change it, alter your email address or username.',
	'CONFIRM_PASSWORD_EXPLAIN'		=> 'You only need to confirm your password if you changed it above',
	'CONFIRM_EMAIL_EXPLAIN'			=> 'You only need to specify this if you are changing your email address.', 

	'UCP_PROFILE_INFO'	=> 'Your Profile', 
	'PROFILE_INFO_NOTICE'	=> 'Please note that this information will be viewable to other members. Be careful when including any personal details. Any fields marked with a * must be completed.',
	'WEBSITE'		=> 'Website',
	'LOCATION'		=> 'Location',
	'CONTACT'		=> 'Contact', 
	'EMAIL_ADDRESS' => 'Email address',
	'INTERESTS'		=> 'Interests',
	'OCCUPATION'	=> 'Occupation',
	'UCP_ICQ'		=> 'ICQ Number',
	'UCP_AIM'		=> 'AOL Instant Messenger',
	'UCP_MSNM'		=> 'MSN Messenger',
	'UCP_YIM'		=> 'Yahoo Messenger',
	'UCP_JABBER'	=> 'Jabber Address', 
	'BIRTHDAY'			=> 'Birthday', 
	'BIRTHDAY_EXPLAIN'	=> 'Setting a year will list your age when it is your birthday.', 

	'UCP_SIGNATURE'		=> 'Your signature', 
	'SIGNATURE_NOTICE'	=> 'Please note that some forums limit the size and content of your signature. Be sure to read any forum or board rules to ensure you comply with them.', 
	'SIGNATURE_PREVIEW' => 'Your signature will appear like this in posts', 
	'SIGNATURE'			=> 'Signature',
	'SIGNATURE_EXPLAIN' => 'This is a block of text that can be added to posts you make. There is a %d character limit',
	'SIGNATURE_TOO_LONG'=> 'Your signature is too long.',

	'UCP_AVATAR'				=> 'Your avatar',
	'AVATAR'					=> 'Avatar',
	'AVATAR_EXPLAIN'			=> 'Maximum dimensions; width %1$d pixels, height %2$d pixels, filesize %3$dkB.',
	'DELETE_AVATAR'				=> 'Delete Image',
	'CURRENT_IMAGE'				=> 'Current Image',
	'UPLOAD_AVATAR_FILE'		=> 'Upload from your machine',
	'UPLOAD_AVATAR_URL'			=> 'Upload from a URL',
	'UPLOAD_AVATAR_URL_EXPLAIN' => 'Enter the URL of the location containing the image, it will be copied to this site.',
	'LINK_REMOTE_AVATAR'		=> 'Link off-site',
	'LINK_REMOTE_AVATAR_EXPLAIN'=> 'Enter the URL of the location containing the Avatar image you wish to link to.',
	'LINK_REMOTE_SIZE'			=> 'Avatar dimensions', 
	'LINK_REMOTE_SIZE_EXPLAIN'	=> 'Specify the width and height of the avatar, leave blank to attempt automatic verification.', 
	'BY'						=> 'by', // Width by Height 
	'AVATAR_GALLERY'			=> 'Select from gallery',
	'AVATAR_CATEGORY'			=> 'Category', 
	'AVATAR_PAGE'				=> 'Page', 

	'AVATAR_URL_INVALID'	=> 'The URL you specified is invalid.', 
	'AVATAR_NOT_UPLOADED'	=> 'Avatar could not be uploaded.', 
	'AVATAR_WRONG_SIZE'		=> 'The avatar must be at least %1$d pixels wide, %2$d pixels high and at most %3$d pixels wide and %4$d pixels high.', 
	'AVATAR_WRONG_FILESIZE'	=> 'The avatar must be between 0 and %d bytes.', 
	'AVATAR_NO_SIZE'		=> 'Could not obtain width or height of linked avatar, please enter them manually.', 

	'PROFILE_UPDATED'	=> 'Your profile has been updated.', 


	'UCP_PREFERENCES'	=> 'Preferences',

	'UCP_PERSONAL'		=> 'Personal Settings', 
	'HIDE_ONLINE'		=> 'Hide my online status',
	'NOTIFY_ON_PM'		=> 'Email me on new private messages',
	'POPUP_ON_PM'		=> 'Pop up window on new private message',
	'SHOW_EMAIL'		=> 'Users can contact me by email',
	'ADMIN_EMAIL'		=> 'Administrators can email me information',
	'BOARD_STYLE'		=> 'My board style',
	'BOARD_LANGUAGE'	=> 'My language', 
	'BOARD_TIMEZONE'	=> 'My timezone', 
	'BOARD_DST'			=> 'Daylight Saving Time is in effect', 
	'BOARD_DATE_FORMAT'			=> 'My date format',
	'BOARD_DATE_FORMAT_EXPLAIN'	=> 'The syntax used is identical to the PHP <a href=\"http://www.php.net/date\" target=\"_other\">date()</a> function', 

	'UCP_VIEW'			=> 'Viewing Posts', 
	'VIEW_IMAGES'		=> 'Display Images within posts', 
	'VIEW_FLASH'		=> 'Display Flash animations', 
	'VIEW_SMILIES'		=> 'Display Smileys as images', 
	'VIEW_SIGS'			=> 'Display Signatures', 
	'VIEW_AVATARS'		=> 'Display Avatars', 
	'DISABLE_CENSORS'	=> 'Enable Word censoring', 
	'MINIMUM_KARMA'		=> 'Minimum User Karma', 
	'MINIMUM_KARMA_EXPLAIN'=> 'Posts by users with Karma less than this will be ignored.', 
	'VIEW_TOPICS_DAYS'	=> 'Display topics from previous days', 
	'VIEW_TOPICS_KEY'	=> 'Display topics ordering by', 
	'VIEW_TOPICS_DIR'	=> 'Display topic order direction', 

	'UCP_POST'			=> 'Posting Messages',
	'DEFAULT_SMILE'		=> 'Enable smilies by default',
	'DEFAULT_HTML'		=> 'Enable HTML by default',
	'DEFAULT_BBCODE'	=> 'Enable BBCode by default',
	'DEFAULT_ADD_SIG'	=> 'Attach my signature by default',
	'DEFAULT_NOTIFY'	=> 'Notify me upon replies by default',

	'PREFERENCES_UPDATED'	=> 'Your preferences have been updated.', 


	'UCP_MESSAGING'		=> 'Messaging', 


	'UCP_LISTS'			=> 'Buddy/Ignore',


	'REGISTRATION'	=> 'Registration',
	'COPPA_BIRTHDAY'	=> 'To continue with the registration procedure please tell us when you were born.', 
	'UCP_COPPA_BEFORE'	=> 'Before %s', 
	'UCP_COPPA_ON_AFTER'=> 'On or After %s', 

	'UCP_AGREEMENT' => 'While the administrators and moderators of this forum will attempt to remove or edit any generally objectionable material as quickly as possible, it is impossible to review every message. Therefore you acknowledge that all posts made to these forums express the views and opinions of the author and not the administrators, moderators or webmaster (except for posts by these people) and hence will not be held liable.<br /><br />You agree not to post any abusive, obscene, vulgar, slanderous, hateful, threatening, sexually-orientated or any other material that may violate any applicable laws. Doing so may lead to you being immediately and permanently banned (and your service provider being informed). The IP address of all posts is recorded to aid in enforcing these conditions. You agree that the webmaster, administrator and moderators of this forum have the right to remove, edit, move or close any topic at any time should they see fit. As a user you agree to any information you	have entered above being stored in a database. While this information will not be disclosed to any third party without your consent the webmaster, administrator and moderators cannot be held responsible for any hacking attempt that may lead to the data being compromised.<br /><br />This forum system uses cookies to store information on your local computer. These cookies do not contain any of the information you have entered above, they serve only to improve your viewing pleasure. The email address is used only for confirming your registration details and password (and for sending new passwords should you forget your current one).<br /><br />By clicking Register below you agree to be bound by these conditions.',
	'UCP_EMAIL_ACTIVATE'=> 'Please note that you will need to enter a valid email address before your account is activated. You will recieve an email at the address you provide that contains an account activation link.',
	'UCP_ADMIN_ACTIVATE'=> 'Please note that you will need to enter a valid email address before your account is activated. The administrator will review your account and if approved you will an email at the address you specified.',
	'NOT_AGREE'			=> 'I do not agree to these terms',
	'AGREE'				=> 'I agree to these terms',

	'CONFIRM_EMAIL'			=> 'Confirm email address', 
	'NEW_PASSWORD'			=> 'Password', 
	'NEW_PASSWORD_EXPLAIN'	=> 'Must be between %1$d and %2$d characters.',
	'CONFIRM_PASSWORD'		=> 'Confirm password',
	'LANGUAGE'				=> 'Language',
	'TIMEZONE'				=> 'Timezone',
	'CONFIRMATION'			=> 'Confirmation of registration', 
	'CONFIRM_EXPLAIN'		=> 'To prevent automated registrations the board administrator requires you to enter a confirmation code. The code is displayed in the image you should see below. If you are visually impaired or cannot otherwise read this code please contact the %sBoard Administrator%s.', 
	'CONFIRM_CODE'			=> 'Confirmation code',
	'CONFIRM_CODE_EXPLAIN'	=> 'Enter the code exactly as you see it in the image, it is case sensitive, zero has a diagonal line through it.',
	'COPPA_COMPLIANCE'		=> 'COPPA Compliance', 
	'COPPA_EXPLAIN'			=> 'Please note that clicking submit will create your account. However it cannot be activated until a parent or guardian approves your registration. You will be emailed a copy of the necessary form with details of where to send it.', 



	'No_user_id_specified' => 'Sorry but that user does not exist',
	'Wrong_Profile' => 'You cannot modify a profile that is not your own.',
	'Only_one_avatar' => 'Only one type of avatar can be specified',
	'File_no_data' => 'The file at the URL you gave contains no data',
	'No_connection_URL' => 'A connection could not be made to the URL you gave',
	'Incomplete_URL' => 'The URL you entered is incomplete',
	'Wrong_remote_avatar_format' => 'The URL of the remote avatar is not valid',
	'No_send_account_inactive' => 'Sorry, but your password cannot be retrieved because your account is currently inactive. Please contact the forum administrator for more information',


	'Profile_updated' => 'Your profile has been updated',
	'Profile_updated_inactive' => 'Your profile has been updated, however you have changed vital details thus your account is now inactive. Check your email to find out how to reactivate your account, or if admin activation is require wait for the administrator to reactivate your account',

	'Fields_empty' => 'You must fill in the required fields',
	'Avatar_filetype' => 'The avatar filetype must be .jpg, .gif or .png',
	'Avatar_filesize' => 'The avatar image file size must be less than %d kB',
	'Welcome_subject' => 'Welcome to %s Forums',
	'New_account_subject' => 'New user account',
	'Account_activated_subject' => 'Account Activated',

	'Account_active' => 'Your account has now been activated. Thank you for registering',
	'Account_active_admin' => 'The account has now been activated',
	'Reactivate' => 'Reactivate your account!',
	'Already_activated' => 'You have already activated your account',




	'PASSWORD_MISMATCH' => 'The passwords you entered did not match',
	'Current_password_mismatch' => 'The current password you supplied does not match that stored in the database',
	'Password_long' => 'Your password must be no more than 32 characters',
	'Username_taken' => 'Sorry but this username has already been taken',
	'Username_invalid' => 'Sorry but this username contains an invalid character such as \'',
	'Username_disallowed' => 'Sorry but this username has been disallowed',
	'Email_taken' => 'Sorry but that email address is already registered to a user',
	'Email_banned' => 'Sorry but this email address has been banned',
	'Email_invalid' => 'Sorry but this email address is invalid',
	'CONFIRM_CODE_WRONG'	=> 'The confirmation code you entered was incorrect.', 
	'TOO_MANY_REGISTERS'	=> 'You have exceeded the maximum number of registration attempts for this session. Please try again later.', 




	'ACCOUNT_ADDED'			=> 'Thank you for registering, your account has been created. You may now login with your username and password',
	'ACCOUNT_INACTIVE'		=> 'Your account has been created. However, this forum requires account activation, an activation key has been sent to the email address you provided. Please check your email for further information',
	'ACCOUNT_INACTIVE_ADMIN'=> 'Your account has been created. However, this forum requires account activation by the administrator. An email has been sent to them and you will be informed when your account has been activated',
	'ACCOUNT_COPPA'			=> 'Your account has been created but has to be approved, please check your email for details.',

	'Wrong_activation'			=> 'The activation key you supplied does not match any in the database',
	'Send_password'				=> 'Send me a new password',
	'Password_updated'			=> 'A new password has been created, please check your email for details on how to activate it',
	'No_email_match'			=> 'The email address you supplied does not match the one listed for that username',
	'New_password_activation'	=> 'New password activation',
	'Password_activated'		=> 'Your account has been re-activated. To logon please use the password supplied in the email you received',


	'COPPA' => 'Your account has been created but has to be approved, please check your email for details.',
);

// usercp_messaging
$lang += array(
	'Private_Messaging' => 'Private Messaging',
	'Unread_message' => 'Unread message',
	'Read_message' => 'Read message',
	'Read_pm' => 'Read message',
	'Post_new_pm' => 'Post message',
	'Post_reply_pm' => 'Reply to message',
	'Post_quote_pm' => 'Quote message',
	'Edit_pm' => 'Edit message',
	'Inbox' => 'Inbox',
	'Outbox' => 'Outbox',
	'Savebox' => 'Savebox',
	'Sentbox' => 'Sentbox',
	'Flag' => 'Flag',
	'SUBJECT' => 'Subject',
	'From' => 'From',
	'To' => 'To',
	'Date' => 'Date',
	'Mark' => 'Mark',
	'Sent' => 'Sent',
	'Saved' => 'Saved',
	'DELETE_MARKED' => 'Delete Marked',
	'Delete_all' => 'Delete All',
	'Save_marked' => 'Save Marked',
	'Save_message' => 'Save Message',
	'DELETE_MESSAGE' => 'Delete Message',
	'Display_messages' => 'Display messages from previous',
	'All_Messages' => 'All Messages',
	'No_messages_folder' => 'You have no messages in this folder',
	'PM_disabled' => 'Private messaging has been disabled on this board',
	'Cannot_send_privmsg' => 'Sorry but the administrator has prevented you from sending private messages',
	'No_to_user' => 'You must specify a username to send this message',
	'No_such_user' => 'Sorry but no such user exists',
	'Disable_HTML_pm' => 'Disable HTML in this message',
	'Disable_BBCode_pm' => 'Disable BBCode in this message',
	'Disable_Smilies_pm' => 'Disable Smilies in this message',
	'Message_sent' => 'Your message has been sent',
	'Click_return_inbox' => 'Click %sHere%s to return to your Inbox',
	'Send_a_new_message' => 'Send a new private message',
	'Send_a_reply' => 'Reply to a private message',
	'Edit_message' => 'Edit private message',
	'Notification_subject' => 'New Private Message has arrived',
	'Find' => 'Find',
	'No_match' => 'No matches found',
	'No_such_folder' => 'No such folder exists',
	'No_folder' => 'No folder specified',
	'MARK_ALL' => 'Mark all',
	'UNMARK_ALL' => 'Unmark all',
	'Confirm_delete_pm' => 'Are you sure you want to delete this message?',
	'Confirm_delete_pms' => 'Are you sure you want to delete these messages?',
	'Inbox_size' => 'Your Inbox is %d%% full',
	'Sentbox_size' => 'Your Sentbox is %d%% full',
	'Savebox_size' => 'Your Savebox is %d%% full',
	'Click_view_privmsg' => 'Click %sHere%s to visit your Inbox',
);

// memberslist
$lang += array(
	'FIND_USERNAME'			=> 'Find a member',
	'FIND_USERNAME_EXPLAIN' => 'Use this form to search for specific members. You do not need to fill out all fields. To match partial data use * as a wildcard. When entering dates use the format yyyy-mm-dd, e.g. 2002-01-01. Use the mark checkboxes to select one or more usernames (several usernames may be accepted depending on the form itself). Alternatively you can mark the users required and click the Insert Marked button.',
	'NO_MEMBERS'	=> 'No members found for this search criteria', 
	'SEND_MESSAGE'	=> 'Message', 
	'POST_IP'		=> 'Posted from IP/domain', 
	'LAST_ACTIVE'	=> 'Last active', 
	'SELECT_SORT_METHOD'=> 'Select sort method',
	'SORT'				=> 'Sort',
	'ORDER'				=> 'Order',
	'SORT_JOINED'		=> 'Joined Date',
	'SORT_USERNAME'		=> 'Username',
	'SORT_LOCATION'		=> 'Location',
	'SORT_POSTS'		=> 'Total posts',
	'SORT_EMAIL'		=> 'Email',
	'SORT_WEBSITE'		=> 'Website',
	'SORT_ASCENDING'	=> 'Ascending',
	'SORT_DESCENDING'	=> 'Descending',
	'SORT_POST_COUNT'	=> 'Post count',
	'SORT_LAST_ACTIVE'	=> 'Last active',
	'LESS_THAN'			=> 'Less than',
	'EQUAL_TO'			=> 'Equal to',
	'MORE_THAN'			=> 'More than',
	'BEFORE'			=> 'Before',
	'AFTER'				=> 'After',
	'NEVER'				=> 'Never',
	'SELECT_MARKED'		=> 'Select Marked',

	'SEND_EMAIL'	=> 'Send Email',
	'NO_EMAIL'		=> 'You are not permitted to send email to this user.',
	'CC_EMAIL'		=> 'Send a copy of this email to yourself',
	'RECIPIENT'		=> 'Recipient', 
	'EMAIL_SENT'	=> 'The email has been sent.',
	'EMAIL_BODY_EXPLAIN'	=> 'This message will be sent as plain text, do not include any HTML or BBCode. The return address for this message will be set to your email address.',
	'EMAIL_TOPIC_EXPLAIN'	=> 'This message will be sent as plain text, do not include any HTML or BBCode. Please note that the topic information is already included in the message. The return address for this message will be set to your email address.',
	'REAL_NAME'			=> 'Recipient Name', 
	'DEST_LANG'			=> 'Language', 
	'DEST_LANG_EXPLAIN'	=> 'Select an appropriate language (if available) for the recipient of this message.', 

	'FLOOD_EMAIL_LIMIT'		=> 'You cannot send another email at this time. Please try again later.',
	'EMPTY_SUBJECT_EMAIL'	=> 'You must specify a subject for the email.',
	'EMPTY_MESSAGE_EMAIL'	=> 'You must enter a message to be emailed.',
	'EMPTY_ADDRESS_EMAIL'	=> 'You must provide a valid email address for the recipient.',
	'EMPTY_NAME_EMAIL'		=> 'You must enter the real name of the recipient.',

	'NO_VIEW_USERS'		=> 'You are not authorised to view the member list or profiles.', 
	'VIEWING_PROFILE'	=> 'Profile view',
	'ABOUT_USER'		=> 'Profile',
	'CONTACT_USER'		=> 'Contact', 
	'USER_FORUM'		=> 'Forum statistics', 
	'USER_PRESENCE'		=> 'Forum presence', 

	'VISITED'		=> 'Last visited', 
	'USER_POST'		=> '%d Post', 
	'USER_POSTS'	=> '%d Posts', 
	'POST_PCT'		=> '%.2f%% of all posts',
	'POST_DAY'		=> '%.2f posts per day',
	'TOTAL_POSTS'	=> 'Total posts', 
	'ACTIVE_IN_FORUM'	=> 'Most active forum', 
	'ACTIVE_IN_TOPIC'	=> 'Most active topic', 
	'SEARCH_USER_POSTS'	=> 'Search users posts', 
	'USER_ONLINE'	=> 'Online', 
	'USER_OFFLINE'	=> 'Offline', 

	'SEND_IM'			=> 'Instant Messaging', 
	'IM_RECIPIENT'		=> 'Recipient', 
	'IM_NAME'			=> 'Your Name', 
	'IM_MESSAGE'		=> 'Your Message', 
	'IM_ICQ'			=> 'Please note that users may have elected to not receive unsolicited instant messages.', 
	'IM_MSN'			=> 'Please note that you need Windows Messenger installed to use this.', 
	'IM_AIM'			=> 'Please note that you need AOL Instant Messenger installed to use this.', 
	'IM_JABBER'			=> 'Please note that users may have elected to not receive unsolicited instant messages.', 
	'IM_ADD_CONTACT'	=> 'Add Contact', 
	'IM_SEND_MESSAGE'	=> 'Send Message', 
	'IM_DOWNLOAD_APP'	=> 'Download Application', 
	'IM_AIM_EXPRESS'	=> 'AIM Express', 
	'IM_SEND'			=> 'Send Message', 
	'IM_NO_JABBER'		=> 'Sorry, direct messaging of Jabber users is not supported on this server. You will need a Jabber client installed on your system to contact the recipient above.', 
	'IM_SENT_JABBER'	=> 'Your message to %1$s has been sent successfully.', 
	'IM_JABBER_SUBJECT' => 'Message from user %1$s at %2$s',  // This needs to be part of a contact template
);

// gcp
$lang += array(
	'Group_Control_Panel' => 'Group Control Panel',
	'Group_member_details' => 'Group Membership Details',
	'Group_member_join' => 'Join a Group',
	'Group_Information' => 'Group Information',
	'Group_name' => 'Group name',
	'Group_description' => 'Group description',
	'Group_membership' => 'Group membership',
	'Group_Members' => 'Group Members',
	'Group_Moderator' => 'Group Moderator',
	'Pending_members' => 'Pending Members',
	'Group_type' => 'Group type',
	'Group_open' => 'Open group',
	'Group_closed' => 'Closed group',
	'Group_hidden' => 'Hidden group',
	'Current_memberships' => 'Current memberships',
	'Non_member_groups' => 'Non-member groups',
	'Memberships_pending' => 'Memberships pending',
	'No_groups_exist' => 'No Groups Exist',
	'Group_not_exist' => 'That user group does not exist',
	'Join_group' => 'Join Group',
	'No_group_members' => 'This group has no members',
	'Group_hidden_members' => 'This group is hidden, you cannot view its membership',
	'No_pending_group_members' => 'This group has no pending members',
	'Group_joined' => 'You have successfully subscribed to this group<br />You will be notified when your subscription is approved by the group moderator',
	'Group_request' => 'A request to join your group has been made',
	'Group_approved' => 'Your request has been approved',
	'Group_added' => 'You have been added to this usergroup',
	'Already_member_group' => 'You are already a member of this group',
	'User_is_member_group' => 'User is already a member of this group',
	'Group_type_updated' => 'Successfully updated group type',
	'Could_not_add_user' => 'The user you selected does not exist',
	'Could_not_anon_user' => 'You cannot make Anonymous a group member',
	'Confirm_unsub' => 'Are you sure you want to unsubscribe from this group?',
	'Confirm_unsub_pending' => 'Your subscription to this group has not yet been approved, are you sure you want to unsubscribe?',
	'Unsub_success' => 'You have been un-subscribed from this group.',
	'Approve_selected' => 'Approve Selected',
	'Deny_selected' => 'Deny Selected',
	'Not_logged_in' => 'You must be logged in to join a group.',
	'Remove_selected' => 'Remove Selected',
	'Add_member' => 'Add Member',
	'Not_group_moderator' => 'You are not this groups moderator therefor you cannot preform that action.',
	'Login_to_join' => 'Login to join or manage group memberships',
	'This_open_group' => 'This is an open group, click to request membership',
	'This_closed_group' => 'This is a closed group, no more users accepted',
	'This_hidden_group' => 'This is a hidden group, automatic user addition is not allowed',
	'Member_this_group' => 'You are a member of this group',
	'Pending_this_group' => 'Your membership of this group is pending',
	'Are_group_moderator' => 'You are the group moderator',
	'NONE' => 'None',
	'Subscribe' => 'Subscribe',
	'Unsubscribe' => 'Unsubscribe',
	'View_Information' => 'View Information',
);

// search
$lang += array(
	'SEARCH_QUERY'		=> 'Search Query',
	'SEARCH_OPTIONS'	=> 'Search Options',

	'SEARCH_KEYWORDS'			=> 'Search for Keywords',
	'SEARCH_KEYWORDS_EXPLAIN'	=> 'Use <b>+</b> for words which must be found, <b>-</b> for words which must not be found and <b>|</b> for words which may or may not be found. Use * as a wildcard for partial matches',

	'SEARCH_AUTHOR'			=> 'Search for Author',
	'SEARCH_AUTHOR_EXPLAIN'	=> 'Use * as a wildcard for partial matches', 
	'SEARCH_FORUMS'			=> 'Search in forums',
	'SEARCH_FORUMS_EXPLAIN'	=> 'Select the forum or forums you wish to search in. For speed all subforums can be searched by selecting the parent and setting enable search subforums below.', 
	'SEARCH_ALL_TERMS'		=> 'Search for all terms or use query as entered',
	'SEARCH_ANY_TERMS'		=> 'Search for any terms',
	'SEARCH_SUBFORUMS'		=> 'Search subforums',
	'SEARCH_WITHIN'			=> 'Search within', 
	'SEARCH_TITLE_MSG'		=> 'Topic titles and message text',
	'SEARCH_MSG_ONLY'		=> 'Message text only',
	'SEARCH_TITLE_ONLY'		=> 'Topic titles only',
	'RETURN_FIRST'			=> 'Return first',
	'POST_CHARACTERS'		=> 'characters of posts',
	'SEARCH_PREVIOUS'		=> 'Search previous',
	'RECENT_SEARCHES'		=> 'Recent searches', 
	'RESULT_DAYS'			=> 'Limit results to previous', 
	'RESULT_SORT'			=> 'Sort results by', 
	'RESULT_DIR'			=> 'Order results', 

	'SORT_BY'			=> 'Sort by',
	'SORT_TIME'			=> 'Post Time',
	'SORT_POST_SUBJECT' => 'Post Subject',
	'SORT_TOPIC_TITLE'	=> 'Topic Title',
	'SORT_AUTHOR'		=> 'Author',
	'SORT_FORUM'		=> 'Forum',
	'LAST_ACTIVE'		=> 'Last active',

	'DISPLAY_RESULTS'	=> 'Display results as',
	'ALL_AVAILABLE'		=> 'All available',
	'ALL_RESULTS'		=> 'All results', 

	'NO_SEARCH'				=> 'Sorry but you are not permitted to use the search system.',
	'NO_SEARCH_RESULTS'		=> 'No suitable matches were found.',
	'FOUND_SEARCH_MATCH'	=> 'Search found %d match',
	'FOUND_SEARCH_MATCHES'	=> 'Search found %d matches',
	'SEARCHED_FOR'			=> 'Search term used', 
	'IGNORED_TERMS'			=> 'ignored', 
	'SEARCH_IN_RESULTS'		=> 'Search these results', 
	
	'NOT_AUTHORISED'	=> 'Not Authorised',
);

// viewonline
$lang += array(
	'REG_USERS_ZERO_ONLINE'		=> 'There are 0 Registered users and ',
	'REG_USERS_ONLINE'			=> 'There are %d Registered users and ',
	'REG_USER_ONLINE'			=> 'There is %d Registered user and ',
	'HIDDEN_USERS_ZERO_ONLINE'	=> '0 Hidden users online',
	'HIDDEN_USERS_ONLINE'		=> '%d Hidden users online',
	'HIDDEN_USER_ONLINE'		=> '%d Hidden user online',
	'GUEST_USERS_ONLINE'		=> 'There are %d Guest users online',
	'GUEST_USERS_ZERO_ONLINE'	=> 'There are 0 Guest users online',
	'GUEST_USER_ONLINE'			=> 'There is %d Guest user online',

	'VIEW_ONLINE_TIME'			=> 'This data is based on users active over the past %d minute', // 1 minute
	'VIEW_ONLINE_TIMES'			=> 'This data is based on users active over the past %d minutes', // 2 minutes, etc.
	'FORUM_LOCATION'			=> 'Forum Location',
	'LAST_UPDATED'				=> 'Last Updated',
	'READING_FORUM'				=> 'Viewing topics in %s', 
	'READING_TOPIC'				=> 'Reading topic in %s',
	'POSTING_MESSAGE'			=> 'Posting message in %s',
	'REPLYING_MESSAGE'			=> 'Replying to message in %s',
	'READING_GLOBAL_ANNOUNCE'	=> 'Reading global announcement', 
	'REPLYING_GLOBAL_ANNOUNCE'	=> 'Replying to global announcement', 
	'SEARCHING_FORUMS'			=> 'Searching forums',
	'VIEWING_ONLINE'			=> 'Viewing who is online',
	'VIEWING_MEMBERS'			=> 'Viewing member details',
	'VIEWING_MESSAGES'			=> 'Viewing Private Messages',
	'VIEWING_FAQ'				=> 'Viewing FAQ', 

	'SEARCHING_FORUMS'			=> 'Searching forums',
	'VIEWING_ONLINE'			=> 'Viewing who is online',
	'VIEWING_MEMBERS'			=> 'Viewing member details',
	'VIEWING_MESSAGES'			=> 'Viewing Private Messages',
	'VIEWING_FAQ'				=> 'Viewing FAQ'
);

//---- MCP lang strings
$lang += array(
	'NOT_MODERATOR'		=> 'You are not a moderator of this forum',

	'FRONT_PAGE'		=>	'Front page',
	'REPORTED_POSTS'	=>	'Reported posts',
	'VIEW_FORUM'		=>	'View forum',
	'VIEW_LOGS'			=>	'View logs',
	'FORUM_INFO'		=>	'Forum info',

	'LATEST_UNAPPROVED'	=>	'Latest 5 posts awaiting for approval',
	'LATEST_REPORTED'	=>	'Latest 5 reports',
	'LATEST_LOGS'		=>	'Latest 5 logged actions',

	'UNAPPROVED_POSTS_ZERO_TOTAL'	=> 	'There are no posts waiting for approval',
	'UNAPPROVED_POSTS_TOTAL'		=> 	'In total there are <b>%d</b> posts waiting for approval',
	'UNAPPROVED_POST_TOTAL'			=> 	'In total there is <b>1</b> post waiting for approval',

	'REPORTS_ZERO_TOTAL'		=> 	'There are no reports to review',
	'REPORTS_TOTAL'				=> 	'In total there are <b>%d</b> reports to review',
	'REPORT_TOTAL'				=> 	'In total there is <b>1</b> report to review',
	'REPORTER'					=>	'Reporter',
	'REPORT_TIME'				=>	'Report time',
	'ALL_REPORTS'				=>	'All reports',
	'REPORT_PRIORITY'		=>	'Priority',
	'REPORTS_CURRENT_TOPIC'		=>	'Currently viewing reports of:',
	'VARIOUS'						=>	'Various',

	'ALL_FORUMS'	=>	'All forums',
	'LOOK_UP_FORUM'	=>	'Select a forum',
	'IP'			=>	'User IP',
	'ACTION'		=>	'Action',

	'DISPLAY_LOG'	=>	'Display entries from previous',
	'ALL_ENTRIES'	=>	'All entries',
	'SORT_IP'		=>	'IP address',
	'SORT_DATE'		=>	'Date',
	'SORT_ACTION'	=>	'Log action',
	'NO_ENTRIES'	=>	'No log entries for this period',

	'FORUM_NAME'	=>	'Forum name',
	'FORUM_DESC'	=>	'Description',
	'FORUM_STYLE'	=>	'Forum style',
	'FORUM_STATUS'	=>	'Forum status',
	'LOCKED'		=>	'Locked',
	'UNLOCKED'		=>	'Unlocked',
	'FORUM_UPDATED'	=>	'Forum informations updated successfully',

	'THIS_POST_IP'	=>	'IP for this post',
	'OTHER_IPS'		=>	'Other IP addresses this user has posted from',
	'OTHER_USERS'	=>	'Users posting from this IP',
	'IP_INFO'		=>	'IP Information',
	'LOOKUP_IP'		=>	'Look up IP',
	'LOOKUP_ALL'	=>	'Look up all IP',

	'LOGS_CURRENT_TOPIC'		=>	'Currently viewing logs of:',

	'FORUM_NOT_POSTABLE'		=>	'This forum is not postable',

	'FORUM_NOT_EXIST'			=>	'The forum you selected does not exist',
	'TOPIC_NOT_EXIST'			=>	'The topic you selected does not exist',
	'SELECT_TOPIC'				=>	'Select topic',
	'TOPIC_NUMBER_IS'			=>	'Topic #%d is %s',
	'POST_DETAILS'				=>	'Post details',
	'POST_OPTIONS'				=>	'Post options',
	'CHANGE_POSTER'			=>	'Change poster',

	'DELETE_POSTS'				=>	'Delete posts',
	'CONFIRM_DELETE_POST'		=>	'Are you sure you want to delete this post?',
	'CONFIRM_DELETE_POSTS'		=>	'Are you sure you want to delete these posts?',
	'CONFIRM_DELETE_TOPIC'		=>	'Are you sure you want to delete this topic?',
	'CONFIRM_DELETE_TOPICS'		=>	'Are you sure you want to delete these topics?',
	'POST_REMOVED'				=>	'The selected post has been successfully removed from the database',
	'POSTS_REMOVED'				=>	'The selected posts have been successfully removed from the database',
	'TOPIC_REMOVED'				=>	'The selected topic has been successfully removed from the database',
	'TOPICS_REMOVED'			=>	'The selected topics have been successfully removed from the database',

	'DELETE_SHADOWS_TOPIC'		=>	'Delete shadows pointing to this topic',
	'DELETE_SHADOWS_FORUM'		=>	'Delete shadow topics for this forum',
	'SHADOWS_REMOVED'			=>	'Shadow topics successfully removed from the database',

	'RESYNC'					=>	'Resync',
	'TOPIC_RESYNCHRONISED'		=>	'The selected topic has been resynchronised',
	'TOPICS_RESYNCHRONISED'		=>	'The selected topics have been resynchronised',

	'MOVE'						=>	'Move',
	'UNGLOBALISE_EXPLAIN'		=>	'Before you can change the topic type of a global announcement you have to assign it to a forum where it will be moved to',
	'SELECT_DESTINATION_FORUM'	=>	'Please select a forum for destination',
	'SELECTED_TOPICS'			=>	'You selected the following topic(s)',
	'LEAVE_SHADOW'				=>	'Leave a shadow topic in the old forum',
	'CANNOT_MOVE_GLOBALS'		=>	'Global announcements cannot be moved',
	'TOPIC_MOVED_SUCCESS'		=>	'The selected topic has been successfully moved',
	'TOPICS_MOVED_SUCCESS'		=>	'The selected topics have been successfully moved',

	'FORK'						=>	'Copy',
	'FORK_EXPLAIN'				=>	'Using the form below you can leave a copy of selected thread(s) in the forum you choose. Please note that posts will automatically be approved and attachments will not be included in the copy. If applicable, polls will be copied as well while corresponding votes will not',
	'TOPIC_FORKED_SUCCESS'		=>	'The selected topic has been successfully copied',
	'TOPICS_FORKED_SUCCESS'		=>	'The selected topics have been successfully copied',

	'RETURN_NEW_TOPIC'			=>	'Click %sHere%s to go to the new topic',
	'RETURN_NEW_FORUM'			=>	'Click %sHere%s to go to the destination forum',

	'DISPLAY_OPTIONS'			=>	'Display options',
	'POSTS_PER_PAGE'			=>	'Posts per page',
	'POSTS_PER_PAGE_EXPLAIN'	=>	'(Set to 0 to view all posts)',

	'MERGE_TOPIC'				=>	'Merge topic',
	'MERGE_TOPIC_EXPLAIN'		=>	'Using the form below you can merge selected posts into another topic. These posts will not be reordered and will appear as if the users posted them to the new topic. Please enter the destination topic id or click on the "Select" button to search for one',
	'MERGE_TOPIC_ID'			=>	'Destination topic id',
	'MERGE_POSTS'				=>	'Merge posts',
	'POSTS_MERGED'				=>	'The selected posts have been merged',

	'SPLIT_TOPIC'				=>	'Split topic',
	'SPLIT_TOPIC_EXPLAIN'		=>	'Using the form below you can split a topic in two, either by selecting the posts individually or by splitting at a selected post',
	'SPLIT_SUBJECT'				=>	'New topic title',
	'SPLIT_FORUM'				=>	'Forum for new topic',
	'SPLIT_POSTS'				=>	'Split selected posts',
	'SPLIT_AFTER'				=>	'Split from selected post',
	'TOPIC_SPLIT'				=>	'The selected topic has been split successfully',
	'CANNOT_SPLIT_FIRST_POST'	=>	'You cannot split the first post of a topic',

	'MOD_QUEUE'					=>	'Moderation queue',
	'APPROVE_POSTS'				=>	'Approve posts',
	'DISAPPROVE_POSTS'			=>	'Reject posts',
	'POST_APPROVED'				=>	'The selected post has been approved',
	'POSTS_APPROVED'			=>	'The selected posts have been approved',
	'POST_UNAPPROVED'			=>	'The selected post has been unapproved',
	'POSTS_UNAPPROVED'			=>	'The selected posts have been unapproved',
	'TOPIC_APPROVED'			=>	'The selected topic has been approved',
	'TOPICS_APPROVED'			=>	'The selected topics have been approved',
	'TOPIC_UNAPPROVED'			=>	'The selected topic has been unapproved',
	'TOPICS_UNAPPROVED'			=>	'The selected topics have been unapproved',

	'LOCK'						=>	'Lock',
	'UNLOCK'					=>	'Unlock',
	'TOPIC_LOCKED_SUCCESS'		=>	'The selected topic has been locked',
	'TOPICS_LOCKED_SUCCESS'		=>	'The selected topics have been locked',
	'TOPIC_UNLOCKED_SUCCESS'	=>	'The selected topic has been unlocked',
	'TOPICS_UNLOCKED_SUCCESS'	=>	'The selected topics have been unlocked',

	'NOT_ALLOWED'				=>	'You are not allowed to perform this action.',
	'TOPIC_TYPE_CHANGED'		=>	'Topic type successfully changed',

	'NO_TOPIC_SELECTED'			=>	'You must select at least one topic to perform this action',
	'NO_POST_SELECTED'			=>	'You must select at least one post to perform this action',
	'NO_SUBJECT'				=>	'&lt;No subject&gt;',


	'logm_lock'					=>	'<b>Locked topic</b>',
	'logm_unlock'				=>	'<b>Unlocked topic</b>',
	'logm_move'					=>	'<b>Moved topic</b> from %s',
	'logm_fork'					=>	'<b>Copied topic</b> from %s',
	'logm_split'				=>	'<b>Split topic</b> from topic %s',
	'logm_delete_topic'		=>	'<b>Deleted topic</b> %s',
	'logm_delete_post'		=>	'<b>Deleted post</b> %s',
	'logm_delete_posts'		=>	'<b>Deleted posts</b> %s',
	'logm_approve_topic'	=>	'<b>Approved topic</b>',
	'logm_approve_post'		=>	'<b>Approved post</b> %s',
	'logm_unapprove_topic'	=>	'<b>Unapproved topic</b>',
	'logm_unapprove_post'	=>	'<b>Unapproved post</b> %s',
	'logm_merge'			=>	'<b>Merged posts</b> from topic %s',
	'logm_make_announce'	=>	'<b>Changed topic type</b> to Announcement',
	'logm_make_sticky'		=>	'<b>Changed topic type</b> to Sticky',
	'logm_make_normal'		=>	'<b>Changed topic type</b> to Normal',
	'logm_make_global'		=>	'<b>Changed topic type</b> to Global Announcement'
);

//----- Post reporting
$lang += array(
	'REASON'			=>	'Reason',
	'MORE_INFO'			=>	'Further information',
	'CAN_LEAVE_BLANK'	=>	'This can be left blank.',

	'POST_NOT_EXIST'	=>	'The post you requested does not exist',

	'REPORT_POST_EXPLAIN'	=>	'Use this form to report the selected post to the forum moderators and board administrators. Reporting should generally be used only if the post breaks forum rules.',
	'EMPTY_REPORT'				=>	'You must enter a description when selecting this reason',

	'REPORT_NOTIFY'					=>	'Notify me',
	'REPORT_NOTIFY_EXPLAIN'	=>	'Informs you when your report is dealt with',

	'POST_REPORTED_SUCCESS'		=>	'This post has been successfully reported',
	'ALREADY_REPORTED'				=>	'This post has already been reported',

	'report_reasons'	=> array(
		'TITLE' => array(
			'WAREZ'		=>	'Warez',
			'SPAM'			=>	'Spam',
			'OFF_TOPIC'	=>	'Off-topic',
			'OTHER'			=>	'Other'
		),
		'DESCRIPTION' => array(
			'WAREZ'		=>	'The post contains links to illegal or pirated software',
			'SPAM'			=>	'The reported post has for only purpose to advertise for a website or another product',
			'OFF_TOPIC'	=>	'The reported post is off topic',
			'OTHER'			=>	'The reported post does not fit into any other category, please use the description field'
		)
	)
);

?>